<?php

/*
Mailboy - A Php/MySQL application that offers a web based interface
to administer an email server. It can be used by the server administrator
as well as the email users.
(c) 2009 Emmanuel Revah - manu-at-manurevah.com
http://manurevah.com/blah/en/pages/mailboy

This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/

/* global form*/
$content[forms][policy][action] = "action";
$content[forms][policy][mod] = "mod";
$content[forms][policy][del] = "del";
$content[forms][policy][confirm] = "confirm";
$content[forms][policy][submit_mod_del] = "submit_mod_del";
$content[forms][policy][submit_add] = "submit_add";
/* mod/add form value names */
$content[forms][policy][policy_name] = "policy_name";
$content[forms][policy][virus_lover] = "virus_lover";
$content[forms][policy][spam_lover] = "spam_lover";
$content[forms][policy][banned_files_lover] = "banned_files_lover";
$content[forms][policy][bad_header_lover] = "bad_header_lover";
$content[forms][policy][bypass_virus_checks] = "bypass_virus_checks";
$content[forms][policy][bypass_spam_checks] = "bypass_spam_checks";
$content[forms][policy][bypass_banned_checks] = "bypass_banned_checks";
$content[forms][policy][bypass_header_checks] = "bypass_header_checks";
$content[forms][policy][spam_modifies_subj] = "spam_modifies_subj";
$content[forms][policy][spam_quarantine_to] = "spam_quarantine_to";
$content[forms][policy][spam_tag_level] = "spam_tag_level";
$content[forms][policy][spam_tag2_level] = "spam_tag2_level";
$content[forms][policy][spam_kill_level] = "spam_kill_level";

$yes_no_values = array("virus_lover", "spam_lover", "banned_files_lover", "bad_header_lover", "bypass_virus_checks", "bypass_spam_checks", "bypass_banned_checks", "bypass_header_checks", "spam_modifies_subj");
$yes_no = array("Y", "y", "N", "n");
$number_vals = array("spam_tag_level", "spam_tag2_level", "spam_kill_level");

if ($_POST[submit_mod_del]) {
	if (array_key_exists($content[forms][policy][confirm], $_POST)) {
		if (am_i_server_admin(3)) {
			foreach ($_POST as $k => $v) {
				if (is_numeric($k)) {
					$update_query = "";
					if ($_POST[$k][action] == $content[forms][policy][del]) {
						$policy_name = $_POST[$k][policy_name];
						if (am_i_server_admin(4)) {
							mysql_query("DELETE FROM policy WHERE `id` = '$k';");
							if (!mysql_error()) {
								$content[status][] = "Policy '<strong>$policy_name</strong>' deleted";
							} else {
								$content[errors][] = "Mysql error while deleting '<strong>$policy_name</strong>': ".mysql_error()."";
							}
						} else {
							$content[errors][] = "You may not delete '<strong>$policy_name</strong>'";
						}
					} elseif ($_POST[$k][action] == $content[forms][policy][mod]) {
						// check every f*$%ing thing
						if (empty($_POST[$k][policy_name])) {
							$content[errors][] = 'Policy name is empty';
						} else {
							//$policy_name = $_POST[$k][policy_name];
							$policy_name = mysql_real_escape_string($_POST[$k][policy_name]);
							$update_query = " `policy_name` = '$policy_name',";
							foreach($_POST[$k] as $k2 => $v2) {
								if (in_array($k2, $yes_no_values)) {
									if (in_array($v2, $yes_no)) {
										$v2 = strtoupper($v2);
										$update_query .= " `$k2` = '$v2',";
									} else {
										$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k2'";
									}
								} elseif (in_array($k2, $number_vals)) {
									if (!preg_match_all("#[^0-9\-\.]#", $v2, $matches)) {
										if (is_numeric($v2)) {
											$update_query .= " `$k2` = '$v2',";
										} else {
											$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k2'";
										}
									} else {
										$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k2' ";
									}
								} elseif ($k2 == "spam_quarantine_to") {
									$v2 = strtolower($v2);
									if (preg_match_all("$reg_email", $v2, $matches)) {
										$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k2'";
									} else {
										$update_query .= " `$k2` = '$v2',";
									}
								}
							}
						}
						if (!empty($update_query)) {
							$update_query = rtrim($update_query, ",");
							mysql_query("UPDATE `$db_database`.`policy` SET $update_query WHERE `id` = '$k';");
							if (!mysql_error()) {
								$policy_name = $_POST[$k][policy_name];
								$content[status][] = "Policy '<strong>$policy_name</strong>' updated";
							} else {
								$content[errors][] = "Mysql error while updating '</strong>$policy_name</strong>': ".mysql_error()."";
							}
						} else {
							$content[status][] = "Policy '<strong>$policy_name</strong>' <strong>not</strong> updated";
						}
					}
				}
			}
		} else {
			$content[errors][] = "You do not have the right to do that";
		}
	} else {
		$content[errors][] = "You need to tick the confirmation box";
	}
	if (!is_array($content[errors]) AND !is_array($content[status])) {
		$content[status][] = "Nothing happened";
	}
/* add policies */
} elseif (array_key_exists($content[forms][policy][submit_add], $_POST)) {
	if (am_i_server_admin(2)) {
		foreach ($_POST as $k => $v) {
			if (!$fatal_error) {
				if ($k == "policy_name") {
					if (empty($v)) {
						$content[errors][] = 'Policy name is empty';
						$fatal_error =1;
					} else {
						$policy_name = mysql_real_escape_string($v);
						$insert_query_var = " `policy_name`,";
						$insert_query_val = " '$policy_name',";
					}
				} elseif (in_array($k, $yes_no_values)) {
					if (in_array($v, $yes_no)) {
						$v = strtoupper($v);
						$insert_query_var .= " `$k`,";
						$insert_query_val .= " '$v',";
					} else {
						$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k'";
					}
				} elseif (in_array($k, $number_vals)) {
					if (!preg_match_all("#[^0-9\-\.]#", $v, $matches)) {
						if (is_numeric($v)) {
							$insert_query_var .= " `$k`,";
							$insert_query_val .= " '$v',";
						} else {
							$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k'";
						}
					} else {
						$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k'";
					}
				} elseif ($k == "spam_quarantine_to") {
					$v = strtolower($v);
					if (preg_match_all("$reg_email", $v, $matches)) {
						$content[errors][] = "Policy <strong>$policy_name</strong>: incorrect value for '$k'";
					} else {
						$insert_query_var .= " `$k`,";
						$insert_query_val .= " '$v',";
					}
				}
			}
		}
		if (!empty($insert_query_var) AND !empty($insert_query_val)) {
			$insert_query_var = rtrim($insert_query_var, ",");
			$insert_query_val = rtrim($insert_query_val, ",");
			mysql_query("INSERT INTO `$db_database`.`policy` ($insert_query_var) VALUES ($insert_query_val);");
			if (!mysql_error()) {
				$policy_name = stripslashes($policy_name);
				$content[status][] = "Policy '<strong>$policy_name</strong>' added";
			} else {
				$content[errors][] = "Mysql error while adding '</strong>$policy_name</strong>': ".mysql_error()."";
			}
		} else {
			$content[status][] = "Policy '<strong>$policy_name</strong>' <strong>not</strong> added";
		}
	} else {
		$content[errors][] = "You do not have the right to do that";
	}
}

/* list policies */
$order_stuff = check_order_by('policies');
$content[domains_table][th] = $order_stuff[th];
$order_by = $order_stuff[order_by];
$q = mysql_query("SELECT * FROM policy $order_by");
$x = 1;
while ($data = mysql_fetch_assoc($q)) {
	extract($data);
	foreach ($data as $k => $v) {
		if ($k == "policy_name") {
			$content[policies][$x][$k] = htmlspecialchars($v);
		} else {
			$content[policies][$x][$k] = $v;
		}
	}
$x++;
}

?>
