<?php
/*
Mailboy - A Php/MySQL application that offers a web based interface
to administer an email server. It can be used by the server administrator
as well as the email users.
(c) 2009 Emmanuel Revah - manu-at-manurevah.com
http://manurevah.com/blah/en/pages/mailboy

This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<?	/* show details within a form */
	if ($content[account_detail][user]) {
		if (am_i_admin_of($content[account_detail][domain_id]) OR is_this_mine($content[account_detail][uid])) { ?>
		<form action="" method="post" enctype="multipart/form-data">
		<? } ?>
			<table>
				<tr>
					<th>user</th>
					<th>change password</th>
					<th>policy</th>
					<th>quota (MB)</th>
					<? if (am_i_admin()) { ?><th>admin for domain</th><? } ?>
					<? if (am_i_server_admin()) { ?><th>server admin</th><? } ?>
				</tr>
				<tr>
					<td>
						<input type="text" class="input-text" name="<? echo $content[forms][mod_account][account]; ?>"  value="<? echo $content[account_detail][user]; ?>"
						<? if (!am_i_admin_of($content[account_detail][domain_id])) { ?>
						disabled="disabled"
						<? } ?>
						/>
						@<? echo $content[account_detail][domain]; ?>
					</td>
					<td>
						<input type="password" class="input-text" name="<? echo $content[forms][mod_account][password]; ?>"  value="" />
						<br />
						<input type="password" class="input-text" name="<? echo $content[forms][mod_account][password_verify]; ?>"  value="" />
					</td>
					<td>
						<select name="<? echo $content[forms][mod_account][policy]; ?>" >
						<? foreach ($content[forms][mod_account][policies] as $k => $v) {
							if ($v == $content[account_detail][policy_name]) { ?>
								<option selected="selected" value="<? echo $k; ?>"><? echo $v; ?></option>
							<? } else { ?>
								<option value="<? echo $k; ?>"><? echo $v; ?></option>
							<? }
						}?>
						</select>
					</td>
					<td>
						<input type="text" class="input-text" name="<? echo $content[forms][mod_account][quota]; ?>"  value="<? echo $content[account_detail][quota]; ?>"
						<? if (!am_i_admin_of($content[account_detail][domain_id])) { ?>
						disabled="disabled"
						<? } ?>
						/>
					</td>
					<? if (am_i_admin()) { ?>
					<td>
						<? if ($content[forms][mod_account][domains]) { ?>
							<select name="<? echo $content[forms][mod_account][admin_domains]; ?>[]" id="domains" multiple="multiple" id="domain_select">
							<? foreach ($content[forms][mod_account][domains] as $k => $v) { ?>
								<? if (am_i_admin_of($k)) {  ?>
									<? if (is_array($content[account_detail][admin_of])) { ?>
										<? if (array_key_exists($k, $content[account_detail][admin_of])) { ?>
											<option selected="selected" value="<? echo $k; ?>"><? echo $v; ?></option>
										<? } else { ?>
											<option value="<? echo $k; ?>"><? echo $v; ?></option>
										<? } ?>
									<? } else {  ?>
											<option value="<? echo $k; ?>"><? echo $v; ?></option>
									<? } ?>
								<? } ?>
							<? } ?>
							</select>
						<? } ?>
					</td>
					<? } ?>
					<? if (am_i_server_admin()) { ?>
					<td>
						<input type="checkbox" <? if ($content[account_detail][admin]) { ?> checked="checked" <? } ?> name="<? echo $content[forms][mod_account][admin]; ?>"  value="1" />
					</td>
					<? } ?>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" class="input-submit" name="<? echo $content[forms][mod_account][submit]; ?>" value="Edit" title="Pleas be careful here." />
			</p>
		</form>
	<? }

	/* show alias details within a form */
	if ($content[alias_detail]) { ?>
		<form action="" method="post" enctype="multipart/form-data">
			<table>
				<tr>
					<th>source</th>
					<th>destination</th>
				</tr>
				<tr>
					<td>
						<input type="text" class="input-text" name="<? echo $content[forms][mod_alias][source]; ?>"  value="<? echo $content[alias_detail][source]; ?>"/>
						@<? echo $content[alias_detail][name]; ?>
					</td>
					<td><input type="text" class="input-text" name="<? echo $content[forms][mod_alias][destination]; ?>"  value="<? echo $content[alias_detail][destination]; ?>"/></td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" class="input-submit" name="<? echo $content[forms][mod_alias][submit]; ?>" value="Edit" title="Please be careful here." />
			</p>
		</form>
	<? } ?>
