<? /*

	Template for (per domain):
		- listing accounts
		- listing aliases
		- adding accounts and aliases
		- modify domain settings:
			- domain name
			- default policy

		- links to
			- modify account
			- modify alias
			- link to modify admin accounts

	PUT USABLE VARS AND STUFF HERE

*/?>

<h2><? echo $content[domain][name]; ?></h2>

	<? /* edit domain */ ?>
	<form action="" method="post" enctype="multipart/form-data">
		<table border="1">
			<tr>
				<th>Domain</th>
				<th>Amavis policy</th>
				<th>Default quota (MB)</th>
			</tr>
			<tr>
				<td><input type="text" name="<? echo $content[forms][mod_domain][new_domain]; ?>" id="" value="<? echo $content[domain][name]; ?>" />
				<td>
					<select name="<? echo $content[forms][mod_domain][policy]; ?>" id="">
						<option value="<? echo $content[forms][add_account][default_policy_id]; ?>"><? echo $content[forms][add_account][default_policy]; ?></option>
						<? foreach ($content[forms][mod_domain][policies] as $k => $v) { ?>
						<option value="<? echo $k; ?>"><? echo $v; ?></option>
						<? } ?>
					</select>
				</td>
				<td><input type="text" name="<? echo $content[forms][mod_domain][default_quota]; ?>" id="" value="<? echo $content[domain][default_quota]; ?>"/></td>
			</tr>
		</table>
		<input type="checkbox" name="<? echo $content[forms][mod_domain][mod_domain_confirm]; ?>" id="" value="1" />Are you sure ?
		<input type="submit" name="<? echo $content[forms][mod_domain][submit]; ?>" value="Edit" title="Be fucking careful" />
	</form>


<? /* addmail form */ ?>
	<fieldset>
		<legend>Add account</legend>
		<form action="" method="post" enctype="multipart/form-data">
		<dl>
			<dt><label for="add_account">Account</label></dt>
			<dd><input type="text" name="<? echo $content[forms][add_account][account]; ?>" id="add_account" value="<? echo $content[forms][add_account][new_account]; ?>" /></dd>
			<dt><label for="password">Password</label></dt>
			<dd><input type="password" name="<? echo $content[forms][add_account][password]; ?>" id="password" value="" /></dd>
			<dt><label for="password_verify">Password (verify)</label></dt>
			<dd><input type="password" name="<? echo $content[forms][add_account][password_verify]; ?>" id="password_verify" value="" /></dd>
			<dt><label for="policy">Amavis policy</label></dt>
			<dd><select name="<? echo $content[forms][add_account][policy]; ?>" id="policy">
					<option value="<? echo $content[forms][add_account][default_policy_id]; ?>"><? echo $content[forms][add_account][default_policy]; ?></option>
					<? foreach ($content[forms][add_account][policies] as $k => $v) { ?>
					<option value="<? echo $k; ?>"><? echo $v; ?></option>
					<?php } ?>
				</select>
			</dd>

			<dt><label for="new_account_quota">Quota (0 = no limit)</label></dt>
			<dd><input type="text" name="<? echo $content[forms][add_account][quota]; ?>" id="new_account_quota" value="<? echo $content[forms][add_account][default_quota]; ?>" /></dd>

			<dt><label for="domains">Administer domains</label></dt>
			<dd><select name="<? echo $content[forms][add_account][admin_domains]; ?>[]" id="domains" multiple="multiple" style="height: 88px;">
					<? foreach ($content[forms][add_account][domains] as $k => $v) { ?>
					<option value="<? echo $k; ?>"><? echo $v; ?></option>
					<? } ?>
				</select>
			</dd>
			<dt><label for="global_admin">Server admin</label></dt>
			<dd><input type="checkbox" name="<? echo $content[forms][add_account][admin]; ?>" id="global_admin" value="<? echo $content[forms][add_account][admin]; ?>" />
			<dt></dt>
			<dd><input type="submit" name="<? echo $content[forms][add_account][submit]; ?>" value="Add account" /></dd>
		</dl>
		</form>
	</fieldset>

	<? /* addalias form */ ?>
	<fieldset><legend>Add Alias</legend>
		<form action="" method="post" enctype="multipart/form-data">
		<dl>
			<dt><label for="add_alias_src">Source (without domain suffix)</label></dt>
			<dd><input type="text" name="<? echo $content[forms][add_alias][alias_src]; ?>" id="add_alias_src" value="<? echo $content[forms][add_alias][new_alias_src]; ?>" /></dd>
			<dt><label for="add_alias_dst">Destination</label></dt>
			<dd><input type="text" name="<? echo $content[forms][add_alias][alias_dst]; ?>" id="add_alias_dst" value="<? echo $content[forms][add_alias][new_alias_dst]; ?>" /></dd>
			<dt></dt>
			<dd><input type="submit" name="<? echo $content[forms][add_alias][submit]; ?>" value="Add alias" /></dd>
		</dl>
		</form>
	</fieldset>

	<? /* list accounts */ ?>
	<? if ($content[accounts]) { ?>
		<h2>Accounts</h2>
		<form action="" method="post" enctype="multipart/form-data">
			<table border="1">
				<tr>
					<th>user</th>
					<th>policy</th>
					<th>quota</th>
					<th>admin for domain</th>
					<th>server admin</th>
					<th>delete ?</th>
				</tr>
			<? foreach ($content[accounts] as $k => $v) { ?>
				<tr>
					<td><a href="index.php?page=account_details&uid=<? echo $v[uid]; ?>"><? echo $v[user]; ?></a></td>
					<td><? echo $v[policy_name]; ?></td>
					<td><? echo $v[quota]; ?></td>
					<td>
						<ul>
				<? if ($content[accounts][$k][admin_of]) {
					foreach ($content[accounts][$k][admin_of] as $k2 => $v2) { ?>
							<li><? echo $v2; ?></li>
					<?}
				}?>
						</ul>
					</td>
					<td>
				<? if ($content[accounts][$k][admin]) { ?>
						yes
				<? } ?>
					</td>
					<td>
						<input type="checkbox" name="<? echo $content[forms][del_account][del_account]; ?>[]" id="" value="<? echo $v[uid]; ?>"/>
					</td>
				</tr>
			<? } ?>
			</table>
			<input type="checkbox" name="<? echo $content[forms][del_account][del_account_confirm]; ?>" id="" value="1"/>Really do it ?
			<input type="submit" name="<? echo $content[forms][del_account][submit]; ?>" value="Delete" title="Be fucking careful" />
		</form>
	<? } ?>

	<? /* list aliases */ ?>
	<? if ($content[aliases]) { ?>
		<h2>Aliases</h2>
	<form action="" method="post" enctype="multipart/form-data">
		<table border="1">
			<tr>
				<th>source</th>
				<th>destination</th>
				<th>delete ?</th>
			</tr>
			<? foreach ($content[aliases] as $k => $v) { ?>
			<tr>
				<td><a href="index.php?page=account_details&alias_id=<?echo $v[id]; ?>"><? echo $v[email]; ?></a></td>
				<td><? echo $v[destination]; ?></td>
				<td>
					<input type="checkbox" name="<? echo $content[forms][del_alias][del_alias]; ?>[]" id="" value="<? echo $v[id]; ?>"/>
				</td>
			</tr>
			<? } ?>
		</table>
		<input type="checkbox" name="<? echo $content[forms][del_alias][del_alias_confirm]; ?>" id="" value="1"/>Really do it ?
		<input type="submit" name="<? echo $content[forms][del_alias][submit]; ?>" value="Delete" title="Be fucking careful" />
	</form>
	<? } ?>

	<? /* list admins */
	if ($content[admins]) { ?>
	<h2>Domain admins</h2>
	<ul>
		<? foreach ($content[admins] as $k => $v) { ?>
		<li><a href="index.php?page=account_details&uid=<? echo $content[admins][$k][user_id]; ?>"><? echo $content[admins][$k][email]; ?></a></li>
		<? } ?>
	</ul>
	<? }
?>
